#!/usr/bin/env tclsh

# Copyright (C) Navraj S. Pannu 2006-2007 Leiden University
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

proc rename_input_columns { step mtzin mtzout } {
    global XMLParse

    set outea $XMLParse([join "crank soap run step=$step output ea_columns ea" __])
    set outsigea $XMLParse([join "crank soap run step=$step output ea_columns sigea" __])
    set outfa $XMLParse([join "crank soap run step=$step output fa_columns fa" __])
    set outsigfa $XMLParse([join "crank soap run step=$step output fa_columns sigfa" __])

    set sftools_script "read $mtzin\n set label col EA \n $outea \n set label col SIGEA \n $outsigea\n"
    set sftools_script "$sftools_script set label col FA \n $outfa \n set label col SIGFA \n $outsigfa\n"
    set sftools_script "$sftools_script write $mtzout \n quit \n"

    set command "sftools << \"$sftools_script\""
#   puts $command
    catch {eval exec $command } output 
#   puts $output
}


set inputxml [file join [pwd] [lindex $argv 0]]
if { [file exists $inputxml] == 0 } {
    crank_error "crank::inputxml file does not exist"
}

set crankbin [lindex $argv 1]

source [file join $crankbin crankutils.tcl]

XMLParsefile $inputxml

set mtzin [lindex $argv 2]
set mtzout [lindex $argv 3]

set step $XMLParse(crank__soap__current_step)

set orig_pwd [pwd]

rename_input_columns $step $mtzin $mtzout

exit
