#
# Copyright (C) Navraj Pannu and Steven Ness 2004-2005, Leiden University
# Copyright (C) Navraj Pannu 2006-2008, Leiden University
#   
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#       
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#     

proc afro_run { code crankbin executable crankplugins inputxml inccp4 step } {
    global XMLParse
    global env

    #
    crank_run_message "$step-afro"

    file mkdir $step-afro
    cd $step-afro
    set tag [string trim $XMLParse([join "crank soap run step=$step tag" __])]

    # Set the location of the executable to the crank afro plugin directory
    if { $inccp4 } {
       set executable [file join $env(CBIN) $executable]
    } else {
       set executable [file join $crankbin  $executable]
    }

    runcommand [concat [file join $crankplugins afro xml2afrocom.tcl] $inputxml $executable $crankbin > afro-command.com]
    runcommand [concat [file join $crankplugins afro xml2afrotcl.tcl] $inputxml $executable $crankbin > afro-command.tcl]

    # if operating system is not windows...
    # runcommand [concat chmod ugo+x ./afro-command.com]
    # runcommand [concat ./afro-command.com]

    runcommand [concat tclsh afro-command.tcl]

    runcommand [concat cat afro-logfile]

    runcommand [concat [file join $crankplugins afro crank-rename-afro-output.tcl] $inputxml $crankbin afro.out.mtz rename.out.mtz]
    file copy rename.out.mtz [file join .. workdb crank.out.$tag.mtz]
    file delete rename.out.mtz

    # Copy logfile to main log directory
    file copy afro-logfile [file join .. log $step-afro-logfile]

    cd ..
}

proc afro_reference { } {
    global XMLParse

    puts "Afro:"
    puts "Pannu (2005) unpublished"
    puts ""
}
