#
# Copyright (C) Navraj S. Pannu and Steven Ness 2004-2005, Leiden University
# Copyright (C) Navraj S. Pannu 2006-2007, Leiden University
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

proc dm_proc { arrayname counter } {
    upvar #0 $arrayname array
    global all_subframes

    foreach subframe $all_subframes {
	trace vdelete array(DM_HL_TOGGLE,$counter) w "update_main_scroll $subframe"
	trace vdelete array(DM_DENMOD,$counter) w "update_main_scroll $subframe"
	trace vdelete array(DM_HAND,$counter) w "update_main_scroll $subframe"
    }

    CreateLine line \
	label "DM will be used to determine hand, optmize solvent content and/or density modification"

    OpenSubFrame frame -toggle_display SHOW_ALL_PIPELINE_INPUT open 1

    lappend all_subframes $frame

    CreateLine line \
	label "Input Experimental Columns" \
	widget INPUT_EXPERIMENTAL_COLUMNS -width 55

    CreateLine line \
	label "Input Phase Columns" \
	widget INPUT_PHASE_COLUMNS -width 55

    OpenSubFrame frame -toggle_display DM_HL_TOGGLE,$counter open 1
	 
    CreateLine line \
	label "Input HL Columns" \
	widget INPUT_HL_COLUMNS -width 55
	
    CloseSubFrame
    
    CloseSubFrame

    CreateLine line \
	message "Try to determine correct hand"  \
	label "Determine correct hand" \
	widget DM_HAND

    OpenSubFrame frame -toggle_display DM_HAND,$counter open 1

    lappend all_subframes $frame

    CreateLine line \
        message "The least acceptable difference between the Rfree to distinguish the correct hand" \
        label "Minimum difference between Rfree " \
        widget DM_MARGIN

    CloseSubFrame

    CreateLine line \
	message "Perform density modification"  \
	label "Perform density modification" \
	widget DM_DENMOD

    OpenSubFrame frame -toggle_display DM_DENMOD,$counter open 1

    lappend all_subframes $frame
     
    CreateLine line \
	message "Use Solvent flattening, flatten solvent in unit cell" \
	label "Solvent flattening" \
	widget DM_SOLVENT \
	message "Use  histogram matching - Useful except in structures with metal clusters" \
	label "Histogram matching" \
	widget DM_HISTOGRAM 
    
    CreateLine line \
	message "Output the Hendrickson-Lattman coefficients from the input phasing program" \
	label "Output HL coefficients from input phasing program" \
 	widget DM_HLOUTPUT

    CloseSubFrame

    CreateLine line \
	message "Use HL coefficients for DM input" \
	label "Use HL coefficients for DM input" \
	widget DM_HL_TOGGLE

    # Set basic defaults

    set array(DM_DENMOD,$counter) 1
     
    set array(DM_HLOUTPUT,$counter) 1
     
    set array(DM_SOLVENT,$counter) 1
     
    set array(DM_HISTOGRAM,$counter) 1
     
    set array(DM_HL_TOGGLE,$counter) 1
        
    set array(DM_MARGIN,$counter) 0.0025
}

proc dm_plugin_update { arrayname counter } {
}

proc dm_setup { } {

}
