# Copyright (C) Navraj S. Pannu 2006-2007, Leiden University
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

proc pirate_run { code crankbin executable crankplugins inputxml inccp4 step } {
    global XMLParse
    global env

    crank_run_message "Running $step-pirate"
    
    file mkdir $step-pirate
    cd $step-pirate
    set tag [string trim $XMLParse([join "crank soap run step=$step tag" __])]
    set ncycle 0
    set enant 1
    
    if { $XMLParse([join "crank soap run step=$step pirate density_modify" __]) == "1" } {

	if { [file exists [file join $env(CLIBD) reference_structures reference-1ajr.mtz]] } {
	    set ref [file join $env(CLIBD) reference_structures reference-1ajr.mtz] 
	} else {
	    crank_error "crank::runpirate:: no reference-1ajr.mtz found in subdirectory reference_structures of $CLIBD"
	} 
        set ex [file join $env(CBIN) cpirate]

	runcommand [concat [file join $crankplugins pirate xml2piratecom.tcl] $inputxml $enant $crankbin $ref $ex >& pirate-command.com]
	runcommand [concat [file join $crankplugins pirate xml2piratetcl.tcl] $inputxml $enant $crankbin $ref $ex >& pirate-command.tcl]

        runcommand [concat tclsh pirate-command.tcl]

	runcommand [concat cat pirate-logfile]

	if { [file exists pirate.mtz] } {
	    runcommand [concat [file join $crankplugins pirate crank-rename-pirate-output.tcl] $inputxml $crankbin pirate.mtz rename.out.mtz]
	    file copy rename.out.mtz [file join .. workdb crank.out.$tag.mtz]
	    file delete rename.out.mtz
	} else {
	    crank_error "crank::runpirate:: pirate.mtz file not present.  Exitting."
	}

	if { [file exists pirate.mtz] } {
	    file copy pirate-logfile [file join .. log $step-pirate-logfile]
	    runcommand [concat cat pirate-logfile]
	} else {
	    crank_error "crank::runpirate:: pirate-logfile file not present.  Exitting."
	}

    }

    cd ..
}

proc pirate_reference { } {
    global XMLParse
    
    puts "Pirate:"
    puts "Cowtan, K. (2000) General quadratic functions in real and reciprocal space and"
    puts "their applications to likelihood phasing. Acta Cryst. D56, 1612-1621.\n"
} 
