#!/usr/bin/env tclsh

# Copyright (C) Navraj S. Pannu 2007, Leiden University
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

set mtz2hklcommand  [lindex $argv 0]
set inputmtz        [lindex $argv 1]
set output          [lindex $argv 2]
set d               [lindex $argv 3]
set sigd            [lindex $argv 4]
set intensity       [lindex $argv 5]


if { $intensity == "1" } { 

    set mtz_script "XTAL xtal1\n DNAME data1 \n COLUmn LABIN I=$d SI=$sigd\nOUTH\nOUTPut $output\nEND\n"

    set command "$mtz2hklcommand HKLIN $inputmtz << \"$mtz_script\""
    catch {eval exec $command } output 
#    puts $output
} else {
    set mtz_script "XTAL xtal1\n DNAME data1 \n COLUmn LABIN F=$d SF+=$sigd\nOUTH\nOUTPut $output\nEND\n"

    set command "$mtz2hklcommand HKLIN $inputmtz << \"$mtz_script\""
    catch {eval exec $command } output 
#    puts $output
}
