#
#     Copyright (C) 1999-2004  Liz Potterton, Peter Briggs
#
#     This code is distributed under the terms and conditions of the
#     CCP4 Program Suite Licence Agreement as a CCP4 Library.
#     A copy of the CCP4 licence can be obtained by writing to the
#     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
#
#CCP4i_cvs_Id $Id: pisa_web.tcl,v 1.2 2008/02/25 09:10:45 pjx Exp $
# ======================================================================
# pisa_web.tcl --
#
# This is a dummy interface file that launches a web browser pointing to
# the PISA website at the EBI
#
# CCP4Interface 
#
# =======================================================================

#--------------------------------------------------------------------
proc pisa_web_setup { typedefVar arrayname } {
#--------------------------------------------------------------------

   # Set URL for PISA webpage
   set pisa_url "http://www.ebi.ac.uk/msd-srv/prot_int/pistart.html"

   # Make sure we get rid of waiting message
   PleaseWait

   set action [ChooseOptionDialog "PISA Webservice" "PISA" \
"This task launches a web browser to access the web version of PISA (Protein Interfaces
Surfaces and Assemblies) at

$pisa_url

This version of CCP4i also contains an interface to a local version of PISA on your
system. If you prefer to use this local version then please select the appropriate option." \
	{ "Run PISA locally" "Go to PISA Website" Dismiss } -default 2 ]

  # Go to the ARP/wARP website
  if { [regexp Website $action] } {
    # Launch a browser with the PISA webservice
    open_url $pisa_url -remote
  } elseif { [regexp locally $action] } {
    # Launch the PISA task interface
    RunTask pisa
  }
  return 0
}

#--------------------------------------------------------------------
proc pisa_web_task_window { typedefVar arrayname } {
#--------------------------------------------------------------------
# Dummy procedure required for startup only.
}
