1 MODE $MR_MODE_SELECT
IF {![StringSame $MR_MODE NMA]}
  1 HKLIN \\"$HKLIN_MAIN\\"
  LABELLINE LABIN "F SIGF" 
ENDIF
{ [ IfSet $TITLE ] } TITLE $TITLE

IF {[StringSame $MR_MODE NMA]}
 1 ENSEMBLE $ENSEMBLE_ID_NMA
  - 1 PDBFILE \\"$XYZIN_NMA\\"
  - {[StringSame $RMS_OPTION_NMA IDENT]} IDENT $RMS_NMA
  - {[StringSame $RMS_OPTION_NMA RMS]} RMS $RMS_NMA
 1 NMAPDB
  LOOP N_NMA 1 $N_NMA_MODES
   - 1 MODE $NMA_MODE($N_NMA) 
  ENDLOOP
   - {$TOG_NMA_COMBINATION} COMBINATION $NMA_NCOMB
IF {[StringSame $NMA_PERTURB RMS]}
   - 1 RMS $NMA_RMSINC
   - 1 MAXRMS $NMA_MAXRMS
   - 1 $NMA_DIRECTION
   - {$TOG_NMA_CLASH} CLASH $NMA_CLASH
   - {$TOG_NMA_STRETCH} STRETCH $NMA_STRETCH
ENDIF
IF {[StringSame $NMA_PERTURB DQ]}
  LOOP IDQ 1 $N_NMA_DQ
   - 1 DQ $NMA_DQ($IDQ) 
  ENDLOOP
ENDIF
{$TOG_NMA_METHOD} NMAMETHOD $NMA_METHOD
   - {[StringSame $NMA_METHOD RTB]} NRESIDUES $NMA_NRES
   - {[StringSame $NMA_METHOD RTB]} MAXBLOCKS $NMA_MAXBLOCKS
   - {$TOG_NMA_RADIUS} RADIUS $NMA_RADIUS
   - {$TOG_NMA_FORCE} FORCE $NMA_FORCE
{[StringSame $NMA_EIGEN READ]} EIGEN READ \\"$EIGENIN\\"
{[StringSame $NMA_EIGEN WRITEON]} EIGEN WRITE ON
{[StringSame $NMA_EIGEN WRITEOFF]} EIGEN WRITE OFF
ENDIF

IF {![StringSame $MR_MODE PACK] && ![StringSame $MR_MODE NMA]}

IF {[StringSame $SCATTERING SOLVENT] }
1 COMPOSITION SOLVENT $SCATTERING_SOLVENT 
ENDIF

IF {[StringSame $SCATTERING NRES] }
1 COMPOSITION PROTEIN NRES $SCATTERING_NRES 
ENDIF

IF {[StringSame $SCATTERING COMPONENT] }
LOOP C 1 $N_COMPONENT
{[StringSame $COMP_OPTION($C) MW ]}    COMPOSITION $PROTDNA($C) MW $MW($C) NUMBER $ASYM($C)
{[StringSame $COMP_OPTION($C) FASTA ]} COMPOSITION $PROTDNA($C) SEQ \\"$COMP_FILE($C)\\" NUMBER $ASYM($C)
ENDLOOP
ENDIF

ENDIF

IF {![StringSame $MR_MODE ANISOTROPY CONTENT]}
  IF {![StringSame $MR_MODE NMA]}
    {[IfSet $TOPFILES]} TOPFILES $TOPFILES
  ENDIF
  {$TOG_XYZOUT} XYZOUT $XYZOUT_ONOFF
ENDIF
IF {![StringSame $MR_MODE PACKING CONTENT NMA]}
  {$TOG_HKLOUT} HKLOUT $HKLOUT_ONOFF
  #bins
  IF {$TOG_BINS}
    { ([IfSet $BINS_N] && ([StringSame $BINS_OPTION NUMBER])) || ([IfSet $BINS_W] && ([StringSame $BINS_OPTION WIDTH])) || ([IfSet $BINS_A] && [IfSet $BINS_B] && [IfSet $BINS_C]) } BINS 
  - { [IfSet $BINS_N] && ([StringSame $BINS_OPTION NUMBER]) } NUMBER $BINS_N
  - { [IfSet $BINS_W] && ([StringSame $BINS_OPTION WIDTH]) } WIDTH $BINS_W
  - { ([IfSet $BINS_A] && [IfSet $BINS_B] && [IfSet $BINS_C]) } CUBIC $BINS_A $BINS_B $BINS_C   
  ENDIF
ENDIF

# NB long IF statement re $MR_MODE not being ANISOTROPY or NMA
# the ENDIF is right at end of script
IF {![StringSame $MR_MODE ANISOTROPY NMA]}

IF {![StringSame $MR_MODE CONTENT PACKING]}
!$TOG_ANISO MACANO OFF
$TOG_RESOLUTION RESOLUTION $RESOLUTION_DMAX $RESOLUTION_DMIN_MR
IF {[StringSame $MR_MODE AUTO]}
$TOG_RESOLUTION_AUTO RESOLUTION AUTO $RESOLUTION_AUTO_DMAX $RESOLUTION_AUTO_DMIN
ENDIF
ENDIF

IF {[StringSame $MR_MODE AUTO TRANSLATE]}
CASE $SPACEGROUP_OPTION
CASEMATCH SG_ENANT
  1 SGALTERNATIVE HAND
CASEMATCH SG_ALT
  LOOP N_SPACEGROUP 1 $N_SG
    1 SGALTERNATIVE TEST $PHASER_TEST_SG($N_SPACEGROUP)
  ENDLOOP
CASEMATCH SG_ALL
  1 SGALTERNATIVE ALL
ENDCASE
ENDIF

IF {[StringSame $MR_MODE ROTATE REFINE RESCORE PACK] && ![StringSame $FILE_SPACEGROUP $TEST_SPACEGROUP] && ![StringSame $TEST_SPACEGROUP ""] && $TOG_SPACEGROUP }
  1 SPACEGROUP $TEST_SPACEGROUP
ENDIF

IF {![StringSame $MR_MODE CONTENT]}
LOOP N_ENSEMB 1 $N_ENSEMBLE
  1 ENSEMBLE $ENSEMBLE_ID($N_ENSEMB) 
LOOP N_PDBFILE 1 $N_PDB($N_ENSEMB)
  IF {[StringSame $ENSEMBLE_OPTION($N_ENSEMB) PDB]}
    - 1 PDBFILE \\"$XYZIN($N_ENSEMB,$N_PDBFILE)\\"
    - {[StringSame $RMS_OPTION($N_ENSEMB,$N_PDBFILE) IDENT]} IDENT $RMS($N_ENSEMB,$N_PDBFILE)
    - {[StringSame $RMS_OPTION($N_ENSEMB,$N_PDBFILE) RMS]} RMS $RMS($N_ENSEMB,$N_PDBFILE)
  ELSE
    - 1 HKLIN \\"$HKLIN($N_ENSEMB)\\"
   LABELLINE & "FC PHIC" $N_ENSEMB
    - {[IfSet $ENSEMBLE_EXT_X($N_ENSEMB)]} EXTENT $ENSEMBLE_EXT_X($N_ENSEMB) $ENSEMBLE_EXT_Y($N_ENSEMB) $ENSEMBLE_EXT_Z($N_ENSEMB)
    - {[IfSet $ENSEMBLE_RMS_MTZ($N_ENSEMB)]} RMS $ENSEMBLE_RMS_MTZ($N_ENSEMB)
    - {[IfSet $ENSEMBLE_CEN_X($N_ENSEMB)]} CENTRE $ENSEMBLE_CEN_X($N_ENSEMB) $ENSEMBLE_CEN_Y($N_ENSEMB) $ENSEMBLE_CEN_Z($N_ENSEMB)
    - {[IfSet $ENSEMBLE_PROTMW($N_ENSEMB)]} PROTEIN MW $ENSEMBLE_PROTMW($N_ENSEMB)
    - {[IfSet $ENSEMBLE_NUCLMW($N_ENSEMB)]} NUCL MW $ENSEMBLE_NUCLMW($N_ENSEMB)
  ENDIF  
ENDLOOP
ENDLOOP
ENDIF

CASE $MR_MODE
CASEMATCH ROTATE 

  1 SEARCH ENSEMBLE $MR_ROT_SEARCH_ID
IF {[StringSame $MR_ROT_SEARCH SEARCH_OR]}
  LOOP N_EXT 1 $N_ROT_SEARCH_EXTRA
    - 1 OR ENSEMBLE $MR_ROT_SEARCH_ID_EXTRA($N_EXT)
  ENDLOOP
ENDIF

  IF {[StringSame $MR_MODE_ROT MR_BRF] && [StringSame $BRF_SEARCH_OPTION FULL]}
  1 ROTATE FULL
  ENDIF
  IF {[StringSame $MR_MODE_ROT MR_BRF] && [StringSame $BRF_SEARCH_OPTION AROUND]}
  1 ROTATE AROUND EULER $AROUND_ALPHA $AROUND_BETA $AROUND_GAMMA
  - 1 RANGE $AROUND_EULER_RANGE 
  ENDIF

CASEMATCH REFINE
# nothing to write

CASEMATCH RESCORE
1 TARGET $RESCORE_TARGET_OPTION

CASEMATCH PACK
{$TOG_PACK && [StringSame $PACK_OPTION BEST] } PACK BEST MAX $PACK_BEST_MAX DISTANCE $PACK_DISTANCE
{$TOG_PACK && [StringSame $PACK_OPTION ALL] } PACK ALL DISTANCE $PACK_DISTANCE
{$TOG_PACK && [StringSame $PACK_OPTION ALLOWED]} PACK ALLOW $PACK_ALLOWED_CLASHES DISTANCE $PACK_DISTANCE

CASEMATCH AUTO

IF {[StringSame $MR_SEARCH SEARCH_SIMPLE]}
  LOOP N_SSEAR 1 $N_SIMPLE_SEARCH
    1 SEARCH ENSEMBLE $MR_SIMPLE_ENSEMBLE_ID($N_SSEAR)
    - 1 NUMBER $MR_SIMPLE_ENSEMBLE_NUM($N_SSEAR)
  ENDLOOP
ELSE 
  LOOP N_SEAR 1 $N_SEARCH
    1 SEARCH ENSEMBLE $MR_ENSEMBLE_ID($N_SEAR)
  LOOP N_EXT 1 $N_SEARCH_EXTRA($N_SEAR)
    - 1 OR ENSEMBLE $MR_ENSEMBLE_ID_EXTRA($N_SEAR,$N_EXT)
  ENDLOOP
    - 1 NUMBER $MR_ENSEMBLE_NUM($N_SEAR)
  ENDLOOP
ENDIF

{$TOG_PACK && [StringSame $PACK_OPTION BEST] } PACK BEST MAX $PACK_BEST_MAX DISTANCE $PACK_DISTANCE
{$TOG_PACK && [StringSame $PACK_OPTION ALL] } PACK ALL DISTANCE $PACK_DISTANCE
{$TOG_PACK && [StringSame $PACK_OPTION ALLOWED]} PACK ALLOW $PACK_ALLOWED_CLASHES DISTANCE $PACK_DISTANCE

ENDCASE

IF {[StringSame $MR_MODE_SELECT MR_BTF]}
  CASE $BTF_SEARCH_OPTION
  CASEMATCH FULL
  1 TRANSLATE $BTF_SEARCH_OPTION
  CASEMATCH AROUND
  1 TRANSLATE $BTF_SEARCH_OPTION $COORD_SYS POINT $START_X $START_Y $START_Z
  - 1 RANGE $AROUND_COORD_RANGE
  CASEMATCH REGION
  1 TRANSLATE $BTF_SEARCH_OPTION $COORD_SYS START $START_X $START_Y $START_Z END $END_X $END_Y $END_Z
  CASEMATCH LINE
  1 TRANSLATE $BTF_SEARCH_OPTION $COORD_SYS START $START_X $START_Y $START_Z END $END_X $END_Y $END_Z
  CASEMATCH PLANE
  1 TRANSLATE $BTF_SEARCH_OPTION $PLANE_OPTION
  CASEMATCH DEGENERATE
  1 TRANSLATE $BTF_SEARCH_OPTION $DEGEN_DIR
  ENDCASE
ENDIF

IF {[StringSame $MR_MODE TRANSLATE]}
  1 @ $TRA_RLIST_FILE
ENDIF

IF {![StringSame $MR_MODE TRANSLATE] && ![StringSame $MR_MODE ANISOTROPY]} 
  {[IfSet $SET_SOL_FILE]} @ $SET_SOL_FILE
ENDIF

# Additional parameters
IF {$TOG_FRF_TARGET && [StringSame $MR_MODE_SELECT MR_FRF MR_AUTO]}
  1 TARGET $FRF_TARGET_OPTION
ENDIF
IF {$TOG_FTF_TARGET && [StringSame $MR_MODE_SELECT MR_FTF MR_AUTO]}
  1 TARGET $FTF_TARGET_OPTION
ENDIF
IF {$TOG_LIKELIHOOD_TARGET && !([StringSame $MR_MODE AUTO RESCORE PACK] || [StringSame $MR_MODE_SELECT MR_FRF MR_FTF])}
  1 TARGET $LIKELIHOOD_TARGET_OPTION
ENDIF

#final select rotate
IF {$TOG_FINAL_ROT && [StringSame $MR_MODE AUTO ROTATE ] }
CASE $FINAL_OPTION_ROT
CASEMATCH SIGMA
  {[IfSet $FINAL_SIGMA_ROT]} FINAL ROT SELECT SIGMA $FINAL_SIGMA_ROT
CASEMATCH NPEAKS
  {[IfSet $FINAL_NPEAKS_ROT]} FINAL ROT SELECT NUM $FINAL_NPEAKS_ROT
CASEMATCH PERCENT
  {[IfSet $FINAL_PERCENT_ROT]} FINAL ROT SELECT PERCENT $FINAL_PERCENT_ROT
CASEMATCH ALL
  1 FINAL ROT SELECT ALL
ENDCASE 
ENDIF

#final cluster rotate

#final select translate
IF {$TOG_FINAL_TRA && [StringSame $MR_MODE AUTO TRANSLATE] }
CASE $FINAL_OPTION_TRA
CASEMATCH SIGMA
  {[IfSet $FINAL_SIGMA_TRA]} FINAL TRA SELECT SIGMA $FINAL_SIGMA_TRA
CASEMATCH NPEAKS
  {[IfSet $FINAL_NPEAKS_TRA]} FINAL TRA SELECT NUM $FINAL_NPEAKS_TRA
CASEMATCH PERCENT
  {[IfSet $FINAL_PERCENT_TRA]} FINAL TRA SELECT PERCENT $FINAL_PERCENT_TRA
CASEMATCH ALL
  1 FINAL TRA SELECT ALL
ENDCASE 
ENDIF

{ $TOG_RESCORE_ROT && [StringSame $RESCORE_ONOFF_ROT OFF] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FRF] } RESCORE ROT OFF
{ $TOG_RESCORE_ROT && [StringSame $RESCORE_ONOFF_ROT ON] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FRF] } RESCORE ROT ON

#rescore select rotate
IF { $TOG_RESCORE_SELECT_ROT && [StringSame $RESCORE_ONOFF_ROT ON ] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FRF] }
CASE $RESCORE_OPTION_ROT
CASEMATCH SIGMA
  {[IfSet $RESCORE_SIGMA_ROT]} FINAL ROT STEP 1 SELECT SIGMA $RESCORE_SIGMA_ROT 
CASEMATCH PERCENT
  {[IfSet $RESCORE_PERCENT_ROT]} FINAL ROT STEP 1 SELECT PERCENT $RESCORE_PERCENT_ROT 
CASEMATCH NPEAKS
  {[IfSet $RESCORE_NPEAKS_ROT]} FINAL ROT STEP 1 SELECT NUMBER $RESCORE_NPEAKS_ROT
CASEMATCH ALL
  1 FINAL ROT STEP 1 SELECT ALL
ENDCASE
ENDIF

#rescore cluster rotate
IF { $TOG_RESCORE_CLUSTER_ROT && [StringSame $RESCORE_ONOFF_ROT ON ] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FRF] }
CASE $RESCORE_CLUSTER_OPTION_ROT
CASEMATCH ON
{[IfSet $RESCORE_NDUMP_ROT]} FINAL ROT STEP 1 CLUSTER ON DUMP $RESCORE_NDUMP_ROT | FINAL ROT STEP 1 CLUSTER ON
CASEMATCH OFF
  1 FINAL ROT STEP 1 CLUSTER OFF LOG $RESCORE_LOG_OPTION_ROT
ENDCASE
ENDIF

#save select rotate
IF { $TOG_SAVE_SELECT_ROT && [StringSame $MR_MODE AUTO ROTATE] } 
CASE $SAVE_OPTION_ROT
CASEMATCH SIGMA
  {[IfSet $SAVE_SIGMA_ROT]} FINAL ROT STEP 2 SELECT SIGMA $SAVE_SIGMA_ROT 
CASEMATCH PERCENT
  {[IfSet $SAVE_PERCENT_ROT]} FINAL ROT STEP 2 SELECT PERCENT $SAVE_PERCENT_ROT 
CASEMATCH NPEAKS
  {[IfSet $SAVE_NPEAKS_ROT]} FINAL ROT STEP 2 SELECT NUMBER $SAVE_NPEAKS_ROT
CASEMATCH ALL
  1 FINAL ROT STEP 2 SELECT ALL 
ENDCASE
ENDIF

#save cluster rotate
IF { $TOG_SAVE_CLUSTER_ROT && [StringSame $MR_MODE AUTO ROTATE] }
CASE $SAVE_CLUSTER_OPTION_ROT
CASEMATCH ON
{[IfSet $SAVE_NDUMP_ROT]} FINAL ROT STEP 2 CLUSTER ON DUMP $SAVE_NDUMP_ROT | FINAL ROT STEP 2 CLUSTER ON
CASEMATCH OFF
  1 FINAL ROT STEP 2 CLUSTER OFF LOG $SAVE_LOG_OPTION_ROT
ENDCASE
ENDIF

{ $TOG_RESCORE_TRA && [StringSame $RESCORE_ONOFF_TRA OFF] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FTF] } RESCORE TRA OFF
{ $TOG_RESCORE_TRA && [StringSame $RESCORE_ONOFF_TRA ON] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FTF] } RESCORE TRA ON

#rescore select translate
IF { $TOG_RESCORE_SELECT_TRA && [StringSame $RESCORE_ONOFF_TRA ON] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FTF ] }
CASE $RESCORE_OPTION_TRA
CASEMATCH SIGMA
  {[IfSet $RESCORE_SIGMA_TRA]} FINAL TRA STEP 1 SELECT SIGMA $RESCORE_SIGMA_TRA 
CASEMATCH PERCENT
  {[IfSet $RESCORE_PERCENT_TRA]} FINAL TRA STEP 1 SELECT PERCENT $RESCORE_PERCENT_TRA 
CASEMATCH NPEAKS
  {[IfSet $RESCORE_NPEAKS_TRA]} FINAL TRA STEP 1 SELECT NUMBER $RESCORE_NPEAKS_TRA
CASEMATCH ALL
  1 FINAL TRA STEP 1 SELECT ALL
ENDCASE
ENDIF

#rescore cluster translate
IF { $TOG_RESCORE_CLUSTER_TRA && [StringSame $RESCORE_ONOFF_TRA ON] && [StringSame $MR_MODE_SELECT MR_AUTO MR_FTF] }
CASE $RESCORE_CLUSTER_OPTION_TRA
CASEMATCH ON
{[IfSet $RESCORE_NDUMP_TRA]} FINAL TRA STEP 1 CLUSTER ON DUMP $RESCORE_NDUMP_TRA | FINAL TRA STEP 1 CLUSTER ON
CASEMATCH OFF
  1 FINAL TRA STEP 1 CLUSTER OFF LOG $RESCORE_LOG_OPTION_TRA
ENDCASE
ENDIF

#save select translate
IF { $TOG_SAVE_SELECT_TRA && [StringSame $MR_MODE AUTO TRANSLATE] } 
CASE $SAVE_OPTION_TRA
CASEMATCH SIGMA
  {[IfSet $SAVE_SIGMA_TRA]} FINAL TRA STEP 2 SELECT SIGMA $SAVE_SIGMA_TRA 
CASEMATCH PERCENT
  {[IfSet $SAVE_PERCENT_TRA]} FINAL TRA STEP 2 SELECT PERCENT $SAVE_PERCENT_TRA 
CASEMATCH NPEAKS
  {[IfSet $SAVE_NPEAKS_TRA]} FINAL TRA STEP 2 SELECT NUMBER $SAVE_NPEAKS_TRA
CASEMATCH ALL
  1 FINAL TRA STEP 2 SELECT ALL 
ENDCASE
ENDIF

#save cluster translate
IF { $TOG_SAVE_CLUSTER_TRA && [StringSame $MR_MODE AUTO TRANSLATE] }
CASE $SAVE_CLUSTER_OPTION_TRA
CASEMATCH ON
{[IfSet $SAVE_NDUMP_TRA]} FINAL TRA STEP 2 CLUSTER ON DUMP $SAVE_NDUMP_TRA | FINAL TRA STEP 2 CLUSTER ON
CASEMATCH OFF
  1 FINAL TRA STEP 2 CLUSTER OFF LOG $SAVE_LOG_OPTION_TRA
ENDCASE
ENDIF

IF {$TOG_BOXSCALE && ![StringSame $MR_MODE CONTENT PACK ANISOTROPY] }
{ [IfSet $BOXSCALE] } BOXSCALE $BOXSCALE
- { [StringSame $BOXSCALE_OPTION SELECTED] } ENSEMBLE $BOXSCALE_ENSEMBLE_ID
ENDIF

IF { $TOG_CLMN && [IfSet $CLMN_OUTER] && ( [StringSame $MR_MODE AUTO] || ([StringSame $MR_MODE ROTATE] && ![StringSame $MR_MODE_ROT MR_BRF]) ) }
1 CLMN SPHERE $CLMN_OUTER
ENDIF

IF { $TOG_IPLN && ![StringSame $MR_MODE PACK ANISOTROPY] }
1 IPLN $IPLN_OPTION
ENDIF

IF {$TOG_OUTLIER && ![StringSame $MR_MODE CONTENT PACK ANISOTROPY] }
{ [StringSame $OUTLIER_OPTION OFF] } OUTLIER OFF
{ [StringSame $OUTLIER_OPTION ON] && [IfSet $OUTLIER_PROB] } OUTLIER ON $OUTLIER_PROB
{ [StringSame $OUTLIER_OPTION ON] && ![IfSet $OUTLIER_PROB] } OUTLIER ON
ENDIF

IF {$TOG_PERMUTATIONS && [StringSame $MR_MODE AUTO]}
1 PERMUTATIONS $PERMUTATIONS_ONOFF
ENDIF

IF {$TOG_PURGE && [StringSame $MR_MODE AUTO]}
{ [StringSame $PURGE_ONOFF OFF] } PURGE OFF
{ [StringSame $PURGE_ONOFF ON]  } PURGE ON PERCENT $PURGE_PERCENT
ENDIF

IF {$TOG_SAMPLING && [StringSame $MR_MODE ROTATE]}
   {[IfSet $SAMPLING_ROT]} SAMPLING ROT $SAMPLING_ROT
ENDIF

IF {$TOG_SAMPLING && [StringSame $MR_MODE TRANSLATE]}
   {[IfSet $SAMPLING_TRA]} SAMPLING TRA $SAMPLING_TRA
ENDIF

IF {$TOG_SAMPLING && [StringSame $MR_MODE AUTO]}
   {[IfSet $SAMPLING_ROT]} SAMPLING ROT $SAMPLING_ROT
   - {[IfSet $SAMPLING_TRA]} TRA $SAMPLING_TRA
   {![IfSet $SAMPLING_ROT] && [IfSet $SAMPLING_TRA]} SAMPLING TRA $SAMPLING_TRA
ENDIF

IF { $TOG_SHANNON && ![StringSame $MR_MODE CONTENT PACK ANISOTROPY] }
{[IfSet $SHANNON]} SHANNON $SHANNON
ENDIF

#IF { ![IfSet $PEAKS_SAVE_SIGMA] && ![IfSet $PEAKS_SAVE_NPEAKS] && [IfSet $PEAKS_DUMP] }
#  1 PEAKS DUMP $PEAKS_DUMP
#ENDIF

# NB end of long IF statement re $MR_MODE not being ANISOTROPY or NMA
# Search for "long IF" to find top.
ENDIF

{$TOG_VERBOSE && $TOG_VERBOSE_EXTRA} VERBOSE ON EXTRA
{$TOG_VERBOSE && !$TOG_VERBOSE_EXTRA} VERBOSE ON

1 ROOT \\"$OUTPUT_FILE_ROOT\\"
